#! /usr/bin/env python

import sys, argparse

import storage, cvutils, utils

from numpy.linalg.linalg import inv
from numpy import loadtxt

parser = argparse.ArgumentParser(description='The program displays feature or object trajectories overlaid over the video frames.', epilog = 'Either the configuration filename or the other parameters (at least video and database filenames) need to be provided.')
parser.add_argument('--cfg', dest = 'configFilename', help = 'name of the configuration file')
parser.add_argument('-d', dest = 'databaseFilename', help = 'name of the Sqlite database file')
parser.add_argument('-i', dest = 'videoFilename', help = 'name of the video file')
parser.add_argument('-t', dest = 'trajectoryType', help = 'type of trajectories to display', choices = ['feature', 'object'], default = 'feature')
parser.add_argument('-o', dest = 'homographyFilename', help = 'name of the image to world homography file')
parser.add_argument('-f', dest = 'firstFrameNum', help = 'number of first frame number to display', default = 0, type = int)
parser.add_argument('-r', dest = 'rescale', help = 'rescaling factor for the displayed image', default = 1., type = float)
parser.add_argument('-s', dest = 'nFramesStep', help = 'number of frames between each display', default = 1, type = int)
parser.add_argument('--save-images', dest = 'saveAllImages', help = 'save all images', action = 'store_true')
parser.add_argument('--last-frame', dest = 'lastFrameNum', help = 'number of last frame number to save (for image saving, no display is made)', default = None, type = int)

args = parser.parse_args()

homography = None
if args.configFilename: # consider there is a configuration file
    params = utils.TrackingParameters()
    params.loadConfigFile(args.configFilename)
    videoFilename = params.videoFilename
    databaseFilename = params.databaseFilename
    homography = inv(loadtxt(params.homographyFilename))
    firstFrameNum = params.firstFrameNum

if args.videoFilename != None:
    videoFilename = args.videoFilename
if args.databaseFilename != None:
    databaseFilename = args.databaseFilename
if args.homographyFilename != None:
    homography = inv(loadtxt(args.homographyFilename))            
if args.firstFrameNum != None:
    firstFrameNum = args.firstFrameNum

objects = storage.loadTrajectoriesFromSqlite(databaseFilename, args.trajectoryType)
boundingBoxes = storage.loadBoundingBoxTable(databaseFilename)
cvutils.displayTrajectories(videoFilename, objects, boundingBoxes, homography, firstFrameNum, args.lastFrameNum, rescale = args.rescale, nFramesStep = args.nFramesStep, saveAllImages = args.saveAllImages)
